#include <stdio.h>
#include <stdlib.h>

#include <sys/auxv.h>

static void func1_A(void)
{
	printf("Implementation A\n");
}

static void func1_B(void)
{
	printf("Implementation B\n");
}

static void func1_generic(void)
{
	printf("Generic implementation\n");
}

void func1(void) __attribute__ ((ifunc ("func1_resolver")));

static void (*func1_resolver (void)) (void)
{
#if defined(__FreeBSD__)
  unsigned long hwcap = elf_aux_info(AT_HWCAP, &hwcap, sizeof(unsigned long));
#else
  unsigned long hwcap = getauxval(AT_HWCAP);
#endif


        if (hwcap & 1U)
                return &func1_A;
        else if (hwcap & 2U)
                return &func1_B;
        else
                return &func1_generic;
	
}

